#!/bin/sh
# /home/abacus/C2/alarm_banner.sh - ABACUS alarm banner 
# the next line restarts using wish \
exec wish "$0" "$@"
# -geometry 90x20+0+453

set NODE	localhost
#set NODE small
#set NODE	inco

########################################################################
#
# ORCOL ALARM BANNER
#
# Initial version 980407
########################################################################
cd /home/abacus/
set w .page
############## TITLE set here ##########################################
wm title . [format "CURRENT ALARMS - ABACUS4 " ]
wm geometry . 640x300+0+0
wm geometry . 640x300+0+453
#wm geometry . 640x480+0+0
wm resizable . 0 0


frame $w 
frame $w.frame
pack $w $w.frame
text $w.frame.mess  -wrap word  -width 90 -height 20  -setgrid true -yscrollcommand "$w.frame.s set"
scrollbar $w.frame.s -orient vert -command "$w.frame.mess yview"
pack $w.frame.s -side right -fill y

frame $w.menu -relief raised -bd 2

############## X/Y display stuff defined here ################################

button $w.menu.xycont  -borderwidth 0 -width 40
bind .  <Motion> {    #$w.menu.xycont delete 0 end
		      set blkno_ [$w.frame.mess get "current linestart + 21 chars" "current linestart + 52 chars" ]
		      #set blkno_2 [format "ack: %%-35.35s" $blkno_]
		      $w.menu.xycont configure -text "$blkno_"
		      set destination_display {}
		       }
bind . 	<Leave>	{ $w.menu.xycont configure -text {} }
		       
############## Time/Date stuff defined here ################################
button $w.menu.timdat -borderwidth 0 -width 30 -justify right
 
proc timdat {} {	global w blkno_2 NODE
			catch { $w.menu.timdat configure -text [exec  date "+%A %d-%B-%Y %H:%M:%S"] }
			catch { after cancel timdat }
			after 1000 timdat
			}

timdat

############## Menu stuff defined here ################################
set m $w.menu.file.m
menubutton $w.menu.file -text "  ACKNOWLEDGE  " -menu $m
menu $m -tearoff 0
#$m add separator
#$m add command -label "" -command { bell }
$m add command -label "Acknowledge all" -command {ack_all}
$m add command -label "Acknowledge newest" -command {ack_newest}
# -underline 0
$m add command -label "" -command {  }

set m $w.menu.restart.m
menubutton $w.menu.restart -text "Restart" -menu $m
menu $m -tearoff 0
#$m add command -label "" -command { bell }
$m add command -label "restart" -command { exec /home/abacus/C2/alarm_banner.sh &; exit }
$m add command -label "" -command {  }


pack $w.menu -side top -fill x
pack $w.menu.file  -side left
#pack $w.menu.restart $w.menu.xycont $w.menu.timdat  -side left
pack $w.menu.xycont $w.menu.timdat  -side left
pack $w.frame.mess -side left -fill both -expand true

set family helvetica
set family Courier

proc ack_all {} {
	global w NODE
	for {set i 1} {$i < 20} {incr i 1} {
	set blkno_ [$w.frame.mess get $i.21 $i.27 ]
	set blkno [expr $blkno_ + 0]
#	puts stdout $blkno
	exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama
	}
	
}
proc ack_newest {} {
	global w NODE
	set blkno_ [$w.frame.mess get $i.21 $i.27 ]
	set blkno [expr $blkno_ + 0]
#	puts stdout $blkno
	exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama
}


$w.frame.mess tag configure alarmred 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-* -foreground white -background red
$w.frame.mess tag configure norm 	-font -*-$family-medium-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure bold 	-font -*-$family-Bold-R-Normal--*-120-*-*-*-*-*-*
$w.frame.mess tag configure big 	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure bigcenter 	-justify center  -underline true\
	-font -*-$family-Bold-R-Normal--*-140-*-*-*-*-*-*
$w.frame.mess tag configure verybigblue -justify center -foreground blue -underline true\
	-font -*-$family-Bold-R-Normal--*-240-*-*-*-*-*-*

proc Intext {txt {tgs {norm}} } {
 global w NODE
 $w.frame.mess insert end $txt $tgs
}

#Intext "[exec /home/abacus/acb-alarms.sh ] \n" alarmred
set flasher 0

$w.frame.mess configure -cursor sb_left_arrow
bind $w.frame.mess <1> { 
 set blkno_ [$w.frame.mess get "current linestart + 21 chars" "current linestart + 28 chars" ]
 set blkno [expr $blkno_ + 0]
 exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama
# puts stdout "exec /home/abacus/bashnet $NODE  /home/abacus/eng2 b$blkno,con,ama"
  }
#bind $w.frame.mess <3> { exec /home/abacus/C2/alarm_banner.sh &; exit }

proc update_ {} {
	global w flasher NODE
	
	if { [winfo viewable .] } {
		set scrollpos [$w.frame.mess yview]
		set scrollpos2 [lrange $scrollpos 0 0]
		if { [lrange $scrollpos 0 0] == 0 } {
		  $w.frame.s configure -background darkgreen
		  wm title . [format "CURRENT ALARMS - ABACUS4 " ]
		} else {
		  $w.frame.s configure -background darkred
		  wm title . [format "CURRENT ALARMS - ABACUS4 (LATEST ALARM NOT VISIBLE!!)" ]
		}
	# puts stdout "\[lrange \$scrollpos 0 0\] [lrange $scrollpos 0 0]"
 		$w.frame.mess configure -state normal
		$w.frame.mess delete 1.0 end
		$w.frame.mess insert end "[exec /home/abacus/bashnet $NODE  /home/abacus/alarm | sort -r ] \n" alarmred
		$w.frame.mess yview moveto $scrollpos2
		set scrollpos [$w.frame.mess yview]


		if {$flasher == 0} {
			set flasher 1
			for {set i 1} {$i < 21} {incr i 1} {
			   if {[$w.frame.mess dump -text $i.0] == "text U $i.0"} {
				$w.frame.mess delete $i.52 $i.end
				############ 
				##bell
				 }

			}
		} else {
			set flasher 0
		}

		$w.frame.mess configure -state disabled
	  }
	after 4000 update_
  }
update_
#/home/abacus/alarm | sort -r | head -n 5 | cut -c1-20,26-90

